## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond snapshot 1

%global srcver      1.1
%global commit      2d683e0c53907ebca9abde876dd87af70719e42d
%global shortcommit %(c=%{commit}; echo ${c:0:8})
%global commitdate  20240129
%global snapshotver %{commitdate}.%{shortcommit}

Name:           qbe
Version:        %{srcver}%{?with_snapshot:^%{snapshotver}}
Release:        %autorelease
Summary:        A pure C embeddable compiler backend

License:        MIT
URL:            https://c9x.me/compile/
Source0:        %{url}/release/%{name}-%{srcver}.tar.xz

%if %{with snapshot}
Patch:          0000-snapshot-%{srcver}-%{shortcommit}.patch
%endif

BuildRequires:  gcc
BuildRequires:  make

ExclusiveArch: x86_64 aarch64 riscv64

%description
QBE is a compiler backend that aims to provide 70% of the performance of
industrial optimizing compilers in 10% of the code. QBE fosters language
innovation by offering a compact user-friendly and performant backend. The size
limit constrains QBE to focus on the essential and prevents embarking on a
never-ending path of diminishing returns.


%prep
%autosetup -n %{name}-%{srcver} -p 1


%build
%{!?_auto_set_build_flags:%{set_build_flags}}
%make_build CFLAGS="${CFLAGS} -fPIE -std=c17 -Wall -Wextra -Wpedantic"


%install
%make_install PREFIX=%{_prefix}


%check
%{!?_auto_set_build_flags:%{set_build_flags}}
make check


%files
%license LICENSE
%doc README doc/*
%{_bindir}/%{name}


%changelog
## START: Generated by rpmautospec
* Sun Feb 04 2024 Mike Rochefort <mroche@omenos.dev> - 1.1^20240129.2d683e0c-1
- Rebase to upstream commit 2d683e0c

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Mar 30 2023 Timothée Floure <timothee.floure@posteo.net> - 1.1-1
- Rebase on new upstream release: QBE 1.1

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Sep 15 2022 Timothée Floure <timothee.floure@posteo.net> - 1.0-4
- Remove autorelease macros expanded by rpmautospec in SRPM

* Thu Sep 15 2022 Timothée Floure <timothee.floure@posteo.net> - 1.0-3
- Restore autochangelog macro mangled by SRPM import

* Thu Sep 15 2022 Timothée Floure <timothee.floure@posteo.net> - 1.0-2
- Preserve timestamp on doc files

* Thu Sep 15 2022 Timothée Floure <timothee.floure@posteo.net> - 1.0-1
- Initial import (fedora#212956)
## END: Generated by rpmautospec
